from ctypes import *
import matplotlib.pyplot as plt
import numpy
import os

def Acquisition():                                             #ɼ

    dll = CDLL(os.getcwd() + '\\MPS Driver.dll')               #DLL32bit DLLΪMPS Driver.dll64bit DLLΪMPS Driver_x64.dll

    #ر
    MPSHandle = c_int                                       
    SampleRate = c_int
    DIOMode = c_int
    ChannelNumber = c_int
    SampleNumberPerChannel = c_int

    #ֵ
    SampleRate = 64000                          #
    DIOMode = 0                                 #DIOģʽ
    SampleNumberPerChannel = 6400               #ÿÿͨɼԲʾͶӦÿβεʱ䳤


    #豸
    MPSHandle = dll.MPS_OpenDevice(0)
    if MPSHandle != -1:
        print("The device opens successfully")
    else :
        print("The device failed to open!") 
        exit()

    
    #ȡ豸ͺϢ
    CHARBUFFERTYPE = c_char * 64
    DeviceDescriptor = CHARBUFFERTYPE()
    for i in range(0,64):DeviceDescriptor[i] = 0

    Flag = dll.MPS_GetDeviceDescriptor(DeviceDescriptor,64,MPSHandle)


    ChannelNumber = 4

    #ͨͺŵһλжͨһλΪ2ʱͨΪ2һλΪ4ʱͨΪ4һλΪ8ʱͨΪ8һλΪ616ʱͨΪ16ͺΪMPS-HD2404һλΪ4ʱͨΪ4
    if DeviceDescriptor[9] == b'2':
        ChannelNumber = 2
    if DeviceDescriptor[9] == b'4':
        ChannelNumber = 4
    if DeviceDescriptor[9] == b'8':
        ChannelNumber = 8
    if DeviceDescriptor[9] == b'6':
        ChannelNumber = 16

    #ʼɼBuffer
    INT32ARRAY = c_int32 * (SampleNumberPerChannel*ChannelNumber)
    DataBuffer = INT32ARRAY()
    for i in range( 0, SampleNumberPerChannel * ChannelNumber ):DataBuffer[i] = 0

    #òɼӲ
    Flag = dll.MPS_Configure(SampleRate, DIOMode,MPSHandle);

    #öȡʱ
    Flag = dll.MPS_TimeOut(5000,MPSHandle)

    #ûʹģʽ͵MPS_Startɼ
    if DIOMode != 2:
        Flag = dll.MPS_Start(MPSHandle)

    #ԤȡһݣõķʽԱ⻺ʷݵӰ죬ѡ
    Flag = dll.MPS_DataIn( DataBuffer, 256 ,MPSHandle)
    if Flag == 0:
        print("Device error!") 
        exit()
    #ȡ
    Flag = dll.MPS_DataIn( DataBuffer, SampleNumberPerChannel * ChannelNumber ,MPSHandle)
    if Flag == 0:
        print("Device error!") 
        exit()

    #ֹͣɼ
    Flag = dll.MPS_Stop(MPSHandle)

    #ر豸
    Flag = dll.MPS_CloseDevice(MPSHandle)



    #ݴѹֵ
    FLOATARRAY = c_float * SampleNumberPerChannel

    #趨̲MPS-HD2404MPS-2408MPS-HD2416MPS-HD1608MPS-HD1616Ϊ5.16VMPS-HD1604Ϊ5.2VMPS-HD2402MPS-HD1802Ϊ5.3V
    VoltageRange = 5.16

    CH1Voltages = FLOATARRAY()
    for i in range(0, SampleNumberPerChannel ):CH1Voltages[i] = DataBuffer[i*ChannelNumber] * VoltageRange / 8388608
    CH2Voltages = FLOATARRAY()
    for i in range(0, SampleNumberPerChannel ):CH2Voltages[i] = DataBuffer[i*ChannelNumber + 1] * VoltageRange / 8388608
    
    if ChannelNumber == 4 or ChannelNumber == 8 or ChannelNumber == 16:
        CH3Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH3Voltages[i] = DataBuffer[i*ChannelNumber + 2] * VoltageRange / 8388608
        CH4Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH4Voltages[i] = DataBuffer[i*ChannelNumber + 3] * VoltageRange / 8388608

    if ChannelNumber == 8 or ChannelNumber == 16:
        CH5Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH5Voltages[i] = DataBuffer[i*ChannelNumber + 4] * VoltageRange / 8388608
        CH6Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH6Voltages[i] = DataBuffer[i*ChannelNumber + 5] * VoltageRange / 8388608
        CH7Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH7Voltages[i] = DataBuffer[i*ChannelNumber + 6] * VoltageRange / 8388608
        CH8Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH8Voltages[i] = DataBuffer[i*ChannelNumber + 7] * VoltageRange / 8388608

    if ChannelNumber == 16:
        CH9Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH9Voltages[i] = DataBuffer[i*ChannelNumber + 8] * VoltageRange / 8388608
        CH10Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH10Voltages[i] = DataBuffer[i*ChannelNumber + 9] * VoltageRange / 8388608
        CH11Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH11Voltages[i] = DataBuffer[i*ChannelNumber + 10] * VoltageRange / 8388608
        CH12Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH12Voltages[i] = DataBuffer[i*ChannelNumber + 11] * VoltageRange / 8388608
        CH13Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH13Voltages[i] = DataBuffer[i*ChannelNumber + 12] * VoltageRange / 8388608
        CH14Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH14Voltages[i] = DataBuffer[i*ChannelNumber + 13] * VoltageRange / 8388608
        CH15Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH15Voltages[i] = DataBuffer[i*ChannelNumber + 14] * VoltageRange / 8388608
        CH16Voltages = FLOATARRAY()
        for i in range(0, SampleNumberPerChannel ):CH16Voltages[i] = DataBuffer[i*ChannelNumber + 15] * VoltageRange / 8388608


    #Ʋ
    TimeLegth = c_float 
    TimeLegth = SampleNumberPerChannel/SampleRate
    TimeInterval = 1/SampleRate

    TimeBuffer = numpy.arange(0, TimeLegth, TimeInterval)

    plt.plot(TimeBuffer, CH1Voltages,color='gray', linewidth=1.0, label='CH1') 
    plt.plot(TimeBuffer, CH2Voltages,color='red', linewidth=1.0, label='CH2') 
    if ChannelNumber == 4 or ChannelNumber == 8 or ChannelNumber == 16:
        plt.plot(TimeBuffer, CH3Voltages,color='green', linewidth=1.0, label='CH3') 
        plt.plot(TimeBuffer, CH4Voltages,color='blue', linewidth=1.0, label='CH4') 
    if  ChannelNumber == 8 or ChannelNumber == 16:
        plt.plot(TimeBuffer, CH3Voltages,color='yellow', linewidth=1.0, label='CH5') 
        plt.plot(TimeBuffer, CH4Voltages,color='peru', linewidth=1.0, label='CH6') 
        plt.plot(TimeBuffer, CH5Voltages,color='plum', linewidth=1.0, label='CH7') 
        plt.plot(TimeBuffer, CH6Voltages,color='black', linewidth=1.0, label='CH8') 
    if ChannelNumber == 16:
        plt.plot(TimeBuffer, CH7Voltages,color='gray', linewidth=1.0, label='CH9') 
        plt.plot(TimeBuffer, CH8Voltages,color='pink', linewidth=1.0, label='CH10') 
        plt.plot(TimeBuffer, CH9Voltages,color='y', linewidth=1.0, label='CH11') 
        plt.plot(TimeBuffer, CH10Voltages,color='g', linewidth=1.0, label='CH12') 
        plt.plot(TimeBuffer, CH11Voltages,color='c', linewidth=1.0, label='CH13') 
        plt.plot(TimeBuffer, CH12Voltages,color='b', linewidth=1.0, label='CH14') 
        plt.plot(TimeBuffer, CH13Voltages,color='m', linewidth=1.0, label='CH15') 
        plt.plot(TimeBuffer, CH14Voltages,color='r', linewidth=1.0, label='CH16') 


    plt.xlabel('Time - axis')
    plt.ylabel('Voltage - axis')
    plt.title('MPS Signal Graph')
    plt.legend(loc = 'upper right')
    plt.draw()
    plt.pause(0.01)
    plt.clf()

    #ɼ
    print("Data acquisition is successful !") 
 


    
plt.figure(figsize=(10,5))

#ѭɼ
LoopCounter  = 20
while LoopCounter:
    Acquisition()
    LoopCounter = LoopCounter - 1
    